// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been 
// thoroughly tested under all conditions. Add-in Express, therefore, cannot 
// guarantee its reliability, serviceability or functionality. 

unit LayoutsD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Outlook2000, Office2000, adxAddIn, LayoutsD7_TLB, StdVcl,
  Classes, adxolFormsManager;

type
  TCoLayoutsD7 = class(TadxAddin, ICoLayoutsD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxOlFormsManager1: TadxOlFormsManager;
    adxOlExplorerCommandbar1: TadxOlExplorerCommandbar;
    adxOlInspectorCommandBar1: TadxOlInspectorCommandBar;
    adxRibbonTab1: TadxRibbonTab;
    adxRibbonTab2: TadxRibbonTab;
    procedure adxOlExplorerCommandbar1Controls0Change(Sender: TObject);
    procedure adxRibbonTab2Controls0Controls0Change(Sender: TObject;
      const RibbonControl: IRibbonControl);
    procedure adxRibbonTab1Controls0Controls0Change(Sender: TObject;
      const RibbonControl: IRibbonControl);
    procedure adxOlInspectorCommandBar1Controls0Change(Sender: TObject);
    procedure adxCOMAddInModuleError(const E: Exception;
      var Handled: Boolean);
    procedure adxOlFormsManager1Error(ASender: TObject;
      Args: TadxOlErrorEventArgs);
    procedure adxOlFormsManager1Initialize(ASender: TObject);
    procedure adxOlFormsManager1ADXBeforeFormInstanceCreateEx(
      ASender: TObject; Args: TBeforeFormInstanceCreateEventArgs);
  private
  protected
  public
    function ExplorerComboBox: TadxCommandBarComboBox;
    function InspectorComboBox: TadxCommandBarComboBox;
    procedure SetExplorerLayout(explorerLayoutText: string);
    procedure SetInspectorLayout(inspectorLayoutText: string);
    function InspectorItem: TadxOlFormsCollectionItem;
    function ExplorerItem: TadxOlFormsCollectionItem;
  end;

implementation

uses Unit1, uUtils;

{$R *.dfm}

procedure TAddInModule.adxOlExplorerCommandbar1Controls0Change(
  Sender: TObject);
begin
  self.SetExplorerLayout(ExplorerComboBox.Text);
end;

procedure TAddInModule.adxRibbonTab2Controls0Controls0Change(
  Sender: TObject; const RibbonControl: IRibbonControl);
begin
  if (Sender is TadxRibbonComboBox) then begin
    self.SetInspectorLayout((Sender as TadxRibbonComboBox).Text);
  end;
end;

procedure TAddInModule.adxRibbonTab1Controls0Controls0Change(
  Sender: TObject; const RibbonControl: IRibbonControl);
begin
  if (Sender is TadxRibbonComboBox) then begin
    self.SetInspectorLayout((Sender as TadxRibbonComboBox).Text);
  end;
end;

procedure TAddInModule.adxOlInspectorCommandBar1Controls0Change(
  Sender: TObject);
begin
  self.SetInspectorLayout(InspectorComboBox.Text);
end;

procedure TAddInModule.adxCOMAddInModuleError(const E: Exception;
  var Handled: Boolean);
begin
  Handled := true;
  Common.ShowError(Strings.AddinModuleOnError);
end;

procedure TAddInModule.adxOlFormsManager1Error(ASender: TObject;
  Args: TadxOlErrorEventArgs);
begin
  Args.Handled := true;
  Common.ShowError(Strings.FormsManagerOnError + #13#10 + Args.E.Message);
end;

procedure TAddInModule.adxOlFormsManager1Initialize(ASender: TObject);
begin
  OutlookUtils.InitOutlookVersion(self.OutlookApp.DefaultInterface);
end;

procedure TAddInModule.adxOlFormsManager1ADXBeforeFormInstanceCreateEx(
  ASender: TObject; Args: TBeforeFormInstanceCreateEventArgs);
begin
  if (OutlookUtils.RefreshCurrentFolderExecuting) then begin
    Args.Cancel := true;
  end;

end;

function TAddInModule.ExplorerComboBox: TadxCommandBarComboBox;
begin
  result := adxOlExplorerCommandbar1.Controls[0] as TadxCommandBarComboBox;
end;

function TAddInModule.InspectorComboBox: TadxCommandBarComboBox;
begin
  result := adxOlInspectorCommandBar1.Controls[0] as TadxCommandBarComboBox;
end;

procedure TAddInModule.SetExplorerLayout(explorerLayoutText: string);
begin
  ADXUtils.SetExplorerLayout(ExplorerItem, explorerLayoutText, OutlookApp.DefaultInterface);
end;

function TAddInModule.ExplorerItem: TadxOlFormsCollectionItem;
begin
  result := adxOlFormsManager1.Items[1];
end;

function TAddInModule.InspectorItem: TadxOlFormsCollectionItem;
begin
  result := adxOlFormsManager1.Items[0];
end;

procedure TAddInModule.SetInspectorLayout(inspectorLayoutText: string);
begin
  ADXUtils.SetInspectorLayout(InspectorItem, inspectorLayoutText, OutlookApp.DefaultInterface);
end;

initialization
  TadxFactory.Create(ComServer, TCoLayoutsD7, CLASS_CoLayoutsD7, TAddInModule);

end.
