// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been 
// thoroughly tested under all conditions. Add-in Express, therefore, cannot 
// guarantee its reliability, serviceability or functionality. 

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Outlook2000, adxolFormsManager, StdCtrls;

type
  TadxOlForm1 = class(TadxOlForm)
    Label1: TLabel;
    Label2: TLabel;
    procedure adxOlFormADXBeforeFormShow(Sender: TObject);
    procedure adxOlFormADXSelectionChange(Sender: TObject);
  private
    { Private declarations }
    procedure DisplaySubject(AMailItem: MailItem);

  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
  end;

{NOTE: The adxOlForm1 variable is intended for the exclusive use
       by the TadxOlFormsCollectionItem Designer.
       NEVER use this variable for other purposes.}
var
  adxOlForm1 : TadxOlForm1;

implementation

uses uUtils;

{$R *.DFM}

procedure TadxOlForm1.adxOlFormADXBeforeFormShow(Sender: TObject);
var
  currentItem: IDispatch;
  mlItem: MailItem;
begin
  if (OutlookUtils.RefreshCurrentFolderExecuting) then begin
    self.Visible := false;
  end
  else begin
    if (self.InspectorObj <> nil) then begin
      currentItem := InspectorObj.CurrentItem;
      mlItem := currentItem as MailItem;
      try
        DisplaySubject(mlItem);
      finally
        currentItem := nil;
        mlItem := nil;
      end;
    end;
  end;
end;

procedure TadxOlForm1.DisplaySubject(AMailItem: MailItem);
begin
  if (AMailItem <> nil) then begin
    Label1.Caption := Format(Strings.SubjectOfCurrentEmail, [AMailItem.Subject]);
  end;
end;

procedure TadxOlForm1.adxOlFormADXSelectionChange(Sender: TObject);
var
  selectionItem: IDispatch;
  mlItem: MailItem;
begin
  if (not (self.Item.ExplorerLayout = elWebViewPane)) then begin
    if (ExplorerObj <> nil) then begin
      selectionItem := OutlookUtils.GetExplorerSelectionItem(self.ExplorerObj);
      try
        mlItem := selectionItem as MailItem;
        if (mlItem <> nil) then begin
          DisplaySubject(mlItem);
        end;
        mlItem := nil;
      finally
        selectionItem := nil;
      end;
    end;
  end;

end;

initialization
  RegisterClass(TPersistentClass(TadxOlForm1));

finalization
end.
